import { ArgsValue, GetGen, MaybePromise } from 'nexus/dist/core';
import { ValidationError, string, number, boolean, date, object, array } from 'yup';
import { ObjectShape } from 'yup/lib/object';
declare const rules: {
    string: typeof string;
    number: typeof number;
    boolean: typeof boolean;
    date: typeof date;
    object: typeof object;
    array: typeof array;
};
declare type ValidationRules = typeof rules;
export declare type ValidateResolver<TypeName extends string, FieldName extends string> = (rules: ValidationRules, args: ArgsValue<TypeName, FieldName>, ctx: GetGen<'context'>) => MaybePromise<ObjectShape | void>;
export interface ValidatePluginErrorConfig {
    error: Error | ValidationError;
    args: any;
    ctx: GetGen<'context'>;
}
export interface ValidatePluginConfig {
    formatError?: (config: ValidatePluginErrorConfig) => Error;
}
export declare const defaultFormatError: ({ error, }: ValidatePluginErrorConfig) => Error;
export declare const validatePlugin: (validateConfig?: ValidatePluginConfig) => import("nexus/dist/plugin").NexusPlugin;
export declare class UserInputError extends Error {
    extensions: {
        invalidArgs: string[];
        code: string;
    };
    constructor(message: string, extensions: {
        invalidArgs: string[];
        code?: string;
    });
}
export { ValidationError };
