"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidationError = exports.UserInputError = exports.validatePlugin = exports.defaultFormatError = void 0;
var nexus_1 = require("nexus");
var core_1 = require("nexus/dist/core");
var yup_1 = require("yup");
Object.defineProperty(exports, "ValidationError", { enumerable: true, get: function () { return yup_1.ValidationError; } });
var rules = {
    string: yup_1.string,
    number: yup_1.number,
    boolean: yup_1.boolean,
    date: yup_1.date,
    object: yup_1.object,
    array: yup_1.array,
};
var ValidateResolverImport = core_1.printedGenTypingImport({
    module: 'nexus-validate',
    bindings: ['ValidateResolver'],
});
var fieldDefTypes = core_1.printedGenTyping({
    optional: true,
    name: 'validate',
    description: 'Validate mutation arguments.',
    type: 'ValidateResolver<TypeName, FieldName>',
    imports: [ValidateResolverImport],
});
var defaultFormatError = function (_a) {
    var error = _a.error;
    if (error instanceof yup_1.ValidationError) {
        return new UserInputError(error.message, {
            invalidArgs: error.path ? [error.path] : [],
        });
    }
    return error;
};
exports.defaultFormatError = defaultFormatError;
var validatePlugin = function (validateConfig) {
    if (validateConfig === void 0) { validateConfig = {}; }
    var _a = validateConfig.formatError, formatError = _a === void 0 ? exports.defaultFormatError : _a;
    return nexus_1.plugin({
        name: 'NexusValidate',
        description: 'The validate plugin provides validation for arguments.',
        fieldDefTypes: fieldDefTypes,
        onCreateFieldResolver: function (config) {
            var _this = this;
            var _a, _b;
            var validate = (_b = (_a = config.fieldConfig.extensions) === null || _a === void 0 ? void 0 : _a.nexus) === null || _b === void 0 ? void 0 : _b.config.validate;
            // if the field doesn't have an validate field,
            // don't worry about wrapping the resolver
            if (validate == null) {
                return;
            }
            // if it does have this field, but it's not a function,
            // it's wrong - let's provide a warning
            if (typeof validate !== 'function') {
                console.error('\x1b[33m%s\x1b[0m', "The validate property provided to [" + config.fieldConfig.name + "] with type [" + config.fieldConfig.type + "]. Should be a function, saw [" + typeof validate + "]");
                return;
            }
            if (['Mutation', 'Query'].indexOf(config.parentTypeConfig.name) === -1) {
                console.warn('\x1b[33m%s\x1b[0m', "The validate property was provided to [" + config.fieldConfig.name + "] with parent [" + config.parentTypeConfig.name + "]. Should have parent [Query] or [Mutation].");
            }
            return function (root, args, ctx, info, next) { return __awaiter(_this, void 0, void 0, function () {
                var schemaBase, schema, error_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 4, , 5]);
                            return [4 /*yield*/, validate(rules, args, ctx)];
                        case 1:
                            schemaBase = _a.sent();
                            if (!(typeof schemaBase !== 'undefined')) return [3 /*break*/, 3];
                            schema = yup_1.object().shape(schemaBase);
                            return [4 /*yield*/, schema.validate(args)];
                        case 2:
                            _a.sent();
                            _a.label = 3;
                        case 3: return [2 /*return*/, next(root, args, ctx, info)];
                        case 4:
                            error_1 = _a.sent();
                            throw formatError({ error: error_1, args: args, ctx: ctx });
                        case 5: return [2 /*return*/];
                    }
                });
            }); };
        },
    });
};
exports.validatePlugin = validatePlugin;
var UserInputError = /** @class */ (function (_super) {
    __extends(UserInputError, _super);
    function UserInputError(message, extensions) {
        var _this = _super.call(this, message) || this;
        _this.extensions = __assign(__assign({}, extensions), { code: extensions.code || 'BAD_USER_INPUT' });
        return _this;
    }
    return UserInputError;
}(Error));
exports.UserInputError = UserInputError;
